//-----------------------------------------------------------------
#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Blue
#property  indicator_color2  Red
#property  indicator_width1  2
//-----------------------------------------------------------------

extern int pq =2;
extern int pr = 10;
extern int ps = 5;
extern int trigger =3;

double ErgoCCI[];
double MainCCI[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,ErgoCCI);   SetIndexLabel(0,"Egodic CCI");
   SetIndexBuffer(1,MainCCI);   SetIndexLabel(1,"Trigger Line");
   return(0);
}
int start()
{
   string signal;
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double mtm    = Close[i]- Close[i +1];
      double absmtm =  MathAbs(mtm);
      double var1   = iEma(mtm   ,pq,i,0);
      double var2   = iEma(var1  ,pr,i,1);
      double var2a  = iEma(absmtm,pq,i,2);
      double var2b  = iEma(var2a ,pr,i,3);
      double var2c  = iEma(var2b ,ps,i,4);
         if (var2c != 0)
               ErgoCCI[i] = 500.0 * iEma(var2,ps,i,5)/var2c;
         else  ErgoCCI[i] = 0;
               MainCCI[i] = iEma(ErgoCCI[i],trigger,i,6);
   }
   if (MainCCI[0] >  ErgoCCI[0]) signal = "SHORT";
   if (MainCCI[0] <  ErgoCCI[0]) signal = "LONG";
   if (MainCCI[0] == ErgoCCI[0]) signal = "NEUTRAL";
      IndicatorShortName("FX Sniper's Ergodic CCI & Trigger: "+signal);
   return(0);
   
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][7];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

